a6d07ae814378713b026af60b3971ffe4dd6a484
[privoxy.git] / privoxy-generic.init
1 #!/bin/sh 
2
3 #  ********************************************************************
4
5 #  File        :  $Source: /cvsroot/ijbswa/current/privoxy-generic.init,v $
6
7 #  Purpose     :  This shell script takes care of starting and stopping
8 #                 privoxy.
9
10 #  Copyright   :  Written by and Copyright (C) 2001,2002 the SourceForge
11 #                 Privoxy team. http://www.privoxy.org/
12
13 #                 Based on the Internet Junkbuster originally written
14 #                 by and Copyright (C) 1997 Anonymous Coders and
15 #                 Junkbusters Corporation.  http://www.junkbusters.com
16
17 #                 This program is free software; you can redistribute it
18 #                 and/or modify it under the terms of the GNU General
19 #                 Public License as published by the Free Software
20 #                 Foundation; either version 2 of the License, or (at
21 #                 your option) any later version.
22
23 #                 This program is distributed in the hope that it will
24 #                 be useful, but WITHOUT ANY WARRANTY; without even the
25 #                 implied warranty of MERCHANTABILITY or FITNESS FOR A
26 #                 PARTICULAR PURPOSE.  See the GNU General Public
27 #                 License for more details.
28
29 #                 The GNU General Public License should be included with
30 #                 this file.  If not, you can view it at
31 #                 http://www.gnu.org/copyleft/gpl.html
32 #                 or write to the Free Software Foundation, Inc., 59
33 #                 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
34 #
35 # Developer's NOTE: This script should be tested against a true /bin/sh, which
36 # has notable differences from bash. By design, this script does not try to do
37 # too much, so as to be as cross-platform as possible.
38 #
39
40 #  Revisions   :
41 #     $Log: privoxy-generic.init,v $
42 #     Revision 1.2  2002/09/08 20:27:58  hal9
43 #     -Rewrote script config section.
44 #     -Added comments to script.
45 #     -Tried to add logic to use a --user privoxy, if available.
46 #     -Minor script changes due to 'echo -n' does not work on a true
47 #      /bin/sh system.
48 #
49 #     Revision 1.1  2002/09/06 00:20:26  hal9
50 #     Creating a generic init script, meant to be used on platforms where don't have
51 #     a custom init script.
52 #
53 #     Revision 1.0  2002/09/05 17:14:32  hal9
54 #
55 #######################################################################
56
57 # Is this needed by Solaris?
58 #ident  "@(#)privoxy  1.0     02/09/05"
59
60 # NOTE: This script may require editing to ensure proper location of 
61 # config file, and the privoxy executable. Care should be taken to ensure 
62 # logfile is writable by $P_USER (logfile is defined in config), and that 
63 # there is suitable write access for $P_PIDFILE.
64
65 PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin/:/usr/bin:/sbin:/bin
66 P_NAME=Privoxy
67 # Path to executable.
68 P_DAEMON=privoxy
69 # Full path to location of Privoxy config file. 
70 P_CONF_FILE=./config
71 # Full path to PID file location. Location must be writable by 
72 # whoever runs this script.
73 P_PIDFILE=`pwd`/privoxy.pid
74 # If uncommented, this script will try to run as USER=privoxy, which
75 # may require special handling of config, *.action, trust, logfile, 
76 # jarfile, and pidfile.
77 P_USER=privoxy
78
79 # If a privoxy user is specified, lets try that. /bin/sh does not seem to 
80 # know about $UID.
81 if [ "$USER" = "root" ] && [ -n "$P_USER" ] && id $P_USER >/dev/null; then
82   P_OWNER=$P_USER
83 else 
84   P_OWNER=$USER
85 fi
86
87 if [ ! -f $P_CONF_FILE ]; then
88   echo "Can't find $P_CONF_FILE, exiting."
89   exit 1
90 fi
91
92 case "$1" in
93  
94  start)
95      if [ -f $P_PIDFILE ]; then
96        if kill -0 `cat $P_PIDFILE`; then
97          echo "Error: $NAME is already running, exiting."
98          exit 1
99        else
100          rm -f $P_PIDFILE
101        fi
102      fi
103
104         $P_DAEMON --pidfile $P_PIDFILE --user $P_OWNER $P_CONF_FILE 2>/dev/null
105      
106      if [ $? -eq 0 ]; then
107        echo "Starting $P_NAME, OK." 
108      else
109        echo "Starting $P_NAME, Failed."
110        rm -f $P_PIDFILE
111      fi
112      ;;
113  
114  restart)
115      $0 stop
116      $0 start
117      ;;
118  
119  stop)
120      test ! -f $P_PIDFILE && echo "No $P_PIDFILE file found, exiting." && exit 1
121      kill `cat $P_PIDFILE` &&\
122      echo "Stopping $P_NAME, OK." || echo "Stopping $P_NAME, failed."
123      ;;
124  
125  *)
126      echo "Usage: $0 {start|stop|restart}"
127      exit 1
128      ;;
129
130 esac
131
132 exit 0